aboutsummaryrefslogtreecommitdiffstats
path: root/package/comgt/files/3g.usb
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2010-07-04 18:11:34 +0000
committerJo-Philipp Wich <jow@openwrt.org>2010-07-04 18:11:34 +0000
commita5dd7363e31e6cc01ccff109bfc93b7dcc852e03 (patch)
treeef0c1f8abbdeab52cbef5418402826863c9ee527 /package/comgt/files/3g.usb
parent95d71b860c795112b9d7467786d879df08e4f59f (diff)
downloadupstream-a5dd7363e31e6cc01ccff109bfc93b7dcc852e03.tar.gz
upstream-a5dd7363e31e6cc01ccff109bfc93b7dcc852e03.tar.bz2
upstream-a5dd7363e31e6cc01ccff109bfc93b7dcc852e03.zip
[package] comgt: add usb hotplug handler to bring up 3g ifaces on boot or when the dongle is attached
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@22061 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/comgt/files/3g.usb')
-rw-r--r--package/comgt/files/3g.usb43
1 files changed, 43 insertions, 0 deletions
diff --git a/package/comgt/files/3g.usb b/package/comgt/files/3g.usb
new file mode 100644
index 0000000000..c52646b3dd
--- /dev/null
+++ b/package/comgt/files/3g.usb
@@ -0,0 +1,43 @@
+#!/bin/sh
+
+. /etc/functions.sh
+
+log() {
+ logger -t 3g-hotplug "$@"
+}
+
+find_3g_iface() {
+ local cfg="$1"
+ local tty="$2"
+
+ local proto
+ config_get proto "$cfg" proto
+
+ [ "$proto" = 3g ] && {
+ local auto
+ config_get_bool auto "$cfg" auto 1
+ [ "$auto" = 1 ] || return 0
+
+ local dev
+ config_get dev "$cfg" device
+
+ if [ "${dev##*/}" = "${tty##*/}" ]; then
+ log "Starting interface $cfg for device ${tty##*/}"
+ ( sleep 1; /sbin/ifup "$cfg" ) &
+ fi
+ }
+}
+
+
+if [ "$ACTION" = add ]; then
+ case "$DEVICENAME" in
+ *-*:*.*) config_load network;;
+ *) exit 0;;
+ esac
+
+ local tty
+ for tty in /sys/$DEVPATH/ttyUSB*; do
+ [ -d "$tty" ] || break
+ config_foreach find_3g_iface interface "$tty"
+ done
+fi